package tantra;

import java.io.*;
import java.util.*;

public class IniFile{
	private static String encoding = "MS932";

	
	public static int GetPrivateProfileInt( String section, String key, int _default, String fileName ){
		entry res;
		res = getStringValue( section, key, fileName );
		if( res.bool ){
			int result;
			res.string = res.string.trim();
			try{
				result = Integer.valueOf( res.string );
				return result;
			}catch( Exception e ){
				return _default;
			}
		}else{
			return _default;
		}
	}

	
	public static String GetPrivateProfileString( String section, String key, String _default, String fileName ){
		entry res = getStringValue( section, key, fileName );
		if( res.bool ){
			//System.out.println( "GetPrivateProfilestring;entry.string=" + res.string );
			return res.string;
		}else{
			return _default;
		}
	}

	
	public static void WritePrivateProfileString( String section, String key, String value, String fileName ){
		BufferedWriter bw = null;
		BufferedReader br = null;
		Vector<String> buffer = new Vector<String>();
		try{
			//System.out.println( "section=" + section );
			//System.out.println( "key=" + key );

			// 既存のファイルがあれば、バッファに読込
			if( new File( fileName ).exists() ){
				br = new BufferedReader(
					new InputStreamReader(
						new FileInputStream( fileName ), encoding ) );
				String line;
				while( (line = br.readLine() ) != null ){
						buffer.add( line );
				}
				br.close();
			}

			int section_length = section.length();
			boolean search_section;
			if( section_length <= 0 ){
				search_section = false;
			}else{
				search_section = true;
			}
			//System.out.println( "Write:search_section=" + search_section );

			boolean found = false;
			for( int i = 0; i < buffer.size(); i++ ){
				//System.out.println( "i,buffer(i)=" + i + "," + buffer.elementAt( i ) );
				if( !search_section ){
					String token[] = buffer.elementAt( i ).split( "=" );
					//System.out.println( "token.length=" + token.length );
					// value = ""で登録されている場合、すなわち行が"{key}="となっている場合は、
					// splitしたときにlength == 1となることに注意
					if( (token.length >= 2 && token[0].equals( key )) ||
						(token.length == 1 && token[0].equals( key )) ){
						//System.out.println( "set element" );
						buffer.setElementAt( new String( key + "=" + value ), i );
						found = true;
						break;
					}
					if( section_length > 0 ){
						if( buffer.elementAt( i ).startsWith( "[" ) ){
							//System.out.println( "insert element" );
							buffer.insertElementAt( new String( key + "=" + value ), i );
							found = true;
							i++;
							break;
						}
					}
				}else if( buffer.elementAt( i ).trim().equals( "[" + section + "]" ) ){
					search_section = false;
				}
			}

			// 見つからんかった時
			if( !found ){
				//System.out.println( "not found" );
				if( section_length > 0 && search_section ) buffer.add( "[" + section + "]" );
				buffer.add( key + "=" + value );
			}

			// 書き出し
			bw = new BufferedWriter(
					new OutputStreamWriter(
							new FileOutputStream( fileName ), encoding ) );
			for( int j = 0; j < buffer.size(); j++ ){
				bw.write( buffer.elementAt( j ) );
				bw.newLine();
			}
			bw.close();
		}catch( Exception e ){}

			
	}


	private static entry getStringValue( String section, String key, String fileName ){
		BufferedReader br = null;
		try{
			br = new BufferedReader(
					new InputStreamReader(
							new FileInputStream( fileName ), encoding ) );
			String line;
			int section_length = section.length();
			boolean search_section;
			if( section_length > 0 ){
				search_section = true;
			}else{
				search_section = false;
			}
			//System.out.println( "search_section=" + search_section );

			String target_line = "[" + section + "]";
			while( (line = br.readLine()) != null ){
				line = line.trim();
				if( !search_section ){
					String token[] = line.split( "=" );
					//System.out.println( "token.length=" + token.length );
					if( token.length >= 2 ){
						if( token[0].trim().equals( key )){
							//System.out.println( "key found" );
							br.close();
							return new entry( token[1].trim(), true );
//							result = token[1].trim();
//							System.out.println( "result=" + result );
//							return true;
						}
					}
					if( section_length > 0 ){
						if( line.startsWith( "[" ) ){
							br.close();
							return new entry( "", false );
						}
					}
				}else if( line.equals( target_line ) ){
					//System.out.println( "section found" );
					search_section = false;
				}
			}
			br.close();
			return new entry( "", false );
		}catch( Exception e ){
			try{
				if( br != null ) br.close();
			}catch( Exception ex ){}
			return new entry( "", false );
		}
		
	}


	public static void setEncoding( String value ){
		encoding = value;
	}


	public static String getEncoding(){
		return encoding;
	}

	private static class entry{
		public boolean bool;
		public String string;
		
		public entry( String string, boolean bool ){
			this.bool = bool;
			this.string = string;
		}
	}
}
